package VistaControlador;

import java.awt.Dimension;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.io.IOException;
import java.time.LocalDate;
import java.time.Month;
import java.util.ArrayList;

import javax.swing.JButton;
import javax.swing.JFrame;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTabbedPane;
import javax.swing.JTextArea;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import Logica.Gestion;
import Logica.Meses;
import Logica.Transaccion;

public class Menu extends JFrame{
	protected JPanel panelCentral;
	protected JTabbedPane pestania;
	protected VistaAniadirVisualizar ingresos;
	protected VistaAniadirVisualizar gastos;
	protected VistaPanelLateral panel;
	String nombreDatos;
	Meses meses;
	ArrayList<VistaAniadirVisualizar> pestanias;
	ArrayList<ControladorAniadirVisualizar> controladores;
	BarraOpciones barra;
	protected Gestion datosGastos;
	protected Gestion datosIngresos;
	public Menu() {
		this.barra = new BarraOpciones();
		ControladorBarra controladorBarra = new ControladorBarra(barra, this);
		this.nombreDatos = ".mes";
		setDefaultCloseOperation(javax.swing.WindowConstants.DO_NOTHING_ON_CLOSE);
		 
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosing(java.awt.event.WindowEvent evt) {
                close();
            }
        });
		this.pestania = new JTabbedPane();
		GridBagConstraints constrain = new GridBagConstraints();
		
		this.cargarGestiones(LocalDate.now().getYear(), LocalDate.now().getMonth());
		this.cargarPestanias();
		this.panelCentral = new JPanel();
		this.panelCentral.setLayout(new GridBagLayout());
		this.panel = new VistaPanelLateral(this.meses);
		
		constrain.fill = GridBagConstraints.HORIZONTAL;
		constrain.gridx = 0;
		constrain.gridwidth = 2;
		constrain.gridy = 0;
		constrain.weightx = 0;
		this.panelCentral.add(this.barra,constrain);
		constrain.fill = GridBagConstraints.HORIZONTAL;
		constrain.gridwidth = 1;
		constrain.gridx = 0;
		constrain.gridy = 1;
		constrain.weightx = 0.25;
		this.panelCentral.add(pestania,constrain);
		setTitle("Titulo");
		setSize(new Dimension(420,320));
		setDefaultCloseOperation(3);
		setLocationRelativeTo(null);
		ControladorPanelLateral controlador3 = new ControladorPanelLateral(this.panel, this);
		this.listenerPestania();
		constrain.fill = GridBagConstraints.HORIZONTAL;
		constrain.gridx = 1;
		constrain.gridy = 1;
		constrain.weightx = 0.25;
		this.panelCentral.add(this.panel,constrain);
		this.add(this.panelCentral);
	}
	
	private void close(){
        if (JOptionPane.showConfirmDialog(rootPane, "¿Desea guardar el estado?",
                "Salir del sistema", JOptionPane.YES_NO_OPTION) == JOptionPane.YES_OPTION) {
        	try {
				this.meses.guardarMeses(this.nombreDatos);
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
        }
            System.exit(0);
    }   
	
	private void iniciarMes(int anio, Month mes) {
		this.pestania.removeAll();
		this.listenerPestania();
		meses.aniadirGestion("Ingresos", anio, mes, true);
		meses.aniadirGestion("Gastos", anio, mes, false);
		this.pestanias=new ArrayList<VistaAniadirVisualizar>();
		this.pestanias.add(new VistaAniadirVisualizar(this,meses.getGestionesActuales().get(0)));
		this.pestanias.add(new VistaAniadirVisualizar(this,meses.getGestionesActuales().get(1)));
		this.controladores=new ArrayList<ControladorAniadirVisualizar>();
		this.controladores.add(new ControladorAniadirVisualizar(this.pestanias.get(0)));
		this.controladores.add(new ControladorAniadirVisualizar(this.pestanias.get(1)));
		this.cargarPestanias();
	}
	
	void cargarGestiones(int anio, Month mes) {
		if(this.meses==null) {
			this.meses=new Meses();
			try {
				meses.cargarMeses(this.nombreDatos);
			} catch (ClassNotFoundException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			} catch (IOException e) {
				// TODO Auto-generated catch block
				e.printStackTrace();
			}
		}
		this.meses.elegirMes(anio, mes);
		if(this.meses.getGestionesActuales().size() == 0) {
			this.iniciarMes(anio, mes);
		}else {
			this.cargarMes();
		}
	}
	
	private void cargarMes() {
		this.pestania.removeAll();
		this.listenerPestania();
		if(this.pestanias == null) {
			this.pestanias = new ArrayList<VistaAniadirVisualizar>();
		}else {
			this.pestanias.clear();
		}
		if(this.controladores == null) {
			this.controladores = new ArrayList<ControladorAniadirVisualizar>();
		}else {
			this.controladores.clear();
		}
		for(Gestion gestion:this.meses.getGestionesActuales()) {
			VistaAniadirVisualizar vista = new VistaAniadirVisualizar(this, gestion);
			ControladorAniadirVisualizar controlador = new ControladorAniadirVisualizar(vista);
			vista.iniciarGestion();
			this.pestanias.add(vista);
			this.controladores.add(controlador);
		}
		this.cargarPestanias();
	}
	
	void cargarPestanias() {
		this.pestania.removeAll();
		this.listenerPestania();
		for(VistaAniadirVisualizar vista:this.pestanias) {
			this.pestania.addTab(vista.getName(),vista);
		}
		this.pestania.setSelectedIndex(0);
	}
	
	void aniadirGestion(String nombre, boolean sumaOResta) {
		Gestion gestion=this.meses.aniadirGestion(nombre, VistaPanelLateral.getDate().getYear(), VistaPanelLateral.getDate().getMonth(), sumaOResta);
		VistaAniadirVisualizar vista = new VistaAniadirVisualizar(this, gestion);
		this.pestanias.add(vista);
		this.controladores.add(new ControladorAniadirVisualizar(vista));
		this.pestania.addTab(vista.getName(),vista);
	}
	
	void listenerPestania(){
		if(this.pestania.getChangeListeners().length == 1) {
			this.pestania.addChangeListener((ChangeListener)->{
				if(this.pestania.getTabCount()>0) {
					try {
						this.panel.actualizarDatos(meses.getGestionesActuales().get(this.pestania.getSelectedIndex()));
					}catch (Exception e) {
						// TODO: handle exception
					}
				}
			});
		}
		
	}
	
}
